#include <stdio.h>

#include "LocationList.h"

LocationList::LocationList(){

	size   = 0;
	current= NULL;
	header = NULL;
	tailer = NULL;
}

LocationList::~LocationList(){
	
	Location_record * temp;
	while(header!=NULL){
            temp = (Location_record *)(header->next);
	    delete header->loc;
	    delete header;
	    header =temp;
	}
}

void LocationList::insertLocation(Location * loc){
	
	if (header==NULL){ // first element;
		header = new Location_record;
		header->loc = new Location(loc);
		header->next =NULL;
		tailer = header;
	}else{
           tailer->next = new Location_record;
	   tailer = (Location_record *)(tailer->next);
	   tailer->next =NULL;
	   tailer->loc = new Location(loc);
	}
}

Location * LocationList::getNext(){
   if (current == NULL) {
       current = header;

       //printf("the first one\n");
       return (header->loc);
   }
   else {
       //printf("not the first one\n");
       current = (Location_record *)(current->next); 

       if (current== NULL) return NULL;
       else return (current->loc);
   }
}

void LocationList::initCurrent(){
    current =NULL;
}

void LocationList::dump(){
    
	Location_record *temp = header;
	while (temp!=NULL) {
	    (temp->loc)->dump();
	    temp = (Location_record *)(temp->next);
	}
}

/*main(){

     Location *loc1 = new Location(1);
     Location *loc2 = new Location(2);

     LocationList * locList = new LocationList();
     locList->insertLocation(loc1);
     locList->insertLocation(loc2);

     locList->initCurrent();
     Location * loc;
     while((loc=locList->getNext())!=NULL){
        loc->dump();
     }
}*/ 


