#ifndef __BUILDBTREE__
#define __BUILDBTREE__

#include "node.h"

class BuildBTree {

	public:
		BuildBTree(char key_type, int size, int other_field_len, char* prefix); // size is the length of key
		~BuildBTree();

		void addToLeaf(char* data, char* key); 
		int addToEntry(char*);
		int getFileNum();
		int getOffset();
		void finish();

	private:

		int key_len;
		int other_field_len;
		char key_type;

		char* first_key;
		char* filename_prefix;

		Node* currentLeaf;
		Node* currentEntry;
		Node* root;

};

#endif
