#ifndef __DIRPOOL__
#define __DIRPOOL__

#include "dirlayer.h"
#include "RecordStore.h"
#include "FileStore.h"


class DirPool {
	public:
		DirPool();
		~DirPool();
		void addLayer(DirLayer*);
		void execCmd(char* command); 
		static RecordStore* recordStore;
		static FileStore* fileStore;
		void release(DirLayer*);
	private:
		DirLayer* currentLayer;
		DirLayer* head;

};
#endif
