#include "constant.h"
#include "head.h"
#include "sort.h"
#include "runfile.h"
#include "searchbtree.h"
#include <iostream.h>

#define NUMOFPAGES	800


main() {

	sortStruct* ss;
	int i,j;
	char* buffer;

	ss=new sortStruct[NUMOFPAGES];
	cout<<sizeof(sortStruct)<<endl;
	cout<<sizeof(ushort)<<endl;

	for(i=0; i<NUMOFPAGES; ++i) {
		ss[i].fid=i; 
		ss[i].eid=i;
		ss[i].wfid=i;
		ss[i].weid=i;
		ss[i].value=(i*2) % 20;
		ss[i].value1=ss[i].value*2;
	}
	int num_of_field=2;

	char* fieldType=new char[num_of_field];
	int* fieldSize=new int[num_of_field];
	char** prefix=new char*[num_of_field];
	char temp[256];

	for(j=0; j<num_of_field; ++j) {
		fieldType[j]=(char)INTTYPE;
		fieldSize[j]=sizeof(int);
		sprintf(temp,"f%d_", j);
		prefix[j]=new char[strlen(temp)+1];
		strcpy(prefix[j], temp);
	}

	Sort* sort=new Sort(num_of_field, fieldType, fieldSize, prefix, 3);
	buffer=new char[sizeof(sortStruct)];
	int sizeofInt=sizeof(int);
	int sizeofShort=sizeof(ushort);

	for(i=0; i<NUMOFPAGES; ++i) {
/*
		for(j=0; j<sizeof(sortStruct); ++j) 
			cout<<(int)((char*)(&(ss[i])))[j]<<" ";
		cout<<endl;
*/

		memcpy(buffer, &(ss[i].fid), sizeofInt);
		memcpy(buffer+sizeofInt, &(ss[i].eid), sizeofShort);
		memcpy(buffer+sizeofInt+sizeofShort, &(ss[i].wfid), sizeofInt);
		memcpy(buffer+2*sizeofInt+sizeofShort, &(ss[i].weid), sizeofShort);
		memcpy(buffer+2*sizeofInt+2*sizeofShort, &(ss[i].value), sizeofInt);
		memcpy(buffer+3*sizeofInt+2*sizeofShort, &(ss[i].value1), sizeofInt);
		sort->insertRecord(buffer);
	}
	delete [] buffer;
	sort->Run();
	SearchBTree *search=new SearchBTree("f0_");
	int key=64;
	int* fids, *wfids;
	ushort* eids, *weids;
	int length;
	search->search((char*)(&key), fids, eids, wfids, weids, length);
	cout<<"the result is***************************"<<length<<endl;
	for(i=0;i<length;++i) {
		cout<<fids[i]<<"  "<<eids[i]<<"  "<<wfids[i]<<"  "<<weids[i]<<endl;
	}
	if(length>0) {
	delete [] fids;
	delete [] eids;
	delete [] wfids;
	delete [] weids;
	}
	key=4;
	search->search((char*)(&key), fids, eids, wfids, weids, length);
	cout<<"the result is***************************"<<length<<endl;
	for(i=0;i<length;++i) {
		cout<<fids[i]<<"  "<<eids[i]<<"  "<<wfids[i]<<"  "<<weids[i]<<endl;
	}
	delete [] fieldType;
	delete [] fieldSize;
	for(j=0; j<num_of_field; ++j) delete [] prefix[j];
	delete [] prefix;
	delete sort;
	delete search;
	delete [] ss;
	if(length>0) {
	delete [] fids;
	delete [] eids;
	delete [] wfids;
	delete [] weids;
	}
}
