#include "map.h"
#include "constant.h"
#define INITSIZE	100

Map::Map() {

	maxSize=INITSIZE;
	size=0;
	fileID=new int*[maxSize];
	recordID=new ushort*[maxSize];
	arraySize=new int[maxSize];
}

Map::~Map() {
	int i;
	for(i=0; i<size; ++i) {
		delete [] fileID[i];
		delete [] recordID[i];
	}
	delete [] fileID;
	delete [] recordID;
	delete [] arraySize;
}

void Map::setSize(int numOfEid) {
	fileID[size]=new int[numOfEid];
	recordID[size]=new ushort[numOfEid];
	arraySize[size]=numOfEid;
	size++;
	if(size>=maxSize) {
		int** tempI1;
		int* tempI2;
		ushort** tempU;
		int i;
		tempI1=fileID;
		tempI2=arraySize;
		tempU=recordID;

		maxSize+=maxSize;
		fileID=new int*[maxSize];
		recordID=new ushort*[maxSize];
		arraySize=new int[maxSize];

		for(i=0; i<size; ++i) {
			fileID[i]=tempI1[i];
			recordID[i]=tempU[i];
			arraySize[i]=tempI2[i];
		}
		delete tempI1;
		delete tempI2;
		delete tempU;
	}
}

void Map::setValue(int fid, ushort eid, int wfid, ushort weid) {
	fileID[fid][eid]=wfid;
	recordID[fid][eid]=weid;
}
