#ifndef __PREDIT__
#define __PREDIT__

#include "constant.h"
#include <iostream.h>


class Predit {
	public:
		Predit(char* field_name, int ivalue, int op) {
			field=field_name;
			iValue=ivalue;
			valueType=INTTYPE;
			next=NULL;
			nextType=0;
			this->op=op;
		};

		Predit(char* field_name, char* svalue, int op) {
			field=field_name;
			sValue=svalue;
			valueType=STRINGTYPE;
			next=NULL;
			nextType=0;
			this->op=op;
		};

		~Predit() {
			delete [] field;
			if(valueType==STRINGTYPE) delete [] sValue;
		};

	public:
		char* field;
		char* sValue;
		int iValue;
		char valueType;
		int op;
		Predit* next;
		char nextType;  //0---or, 1---and
};

#endif
