#ifndef __RUNFILE__
#define __RUNFILE__

#include <stdio.h>
#include <sys/time.h>
#include <iostream.h>
class RunFile {

	public:
		RunFile(char* filename,char);
		RunFile(char* filename,char, char&);
		~RunFile();

	void insertRecord(char*, int);
	void deleteFile();

	int getRecord(char*, int);
	static int getFileLen(char* );

	static void setTimeZero() { 
		RunFile::openTime=0; 
		RunFile::closeTime=0; 
		RunFile::readTime=0; 
		RunFile::writeTime=0; 
	};
	static long getOpenTime() { return RunFile::openTime; };
	static long getCloseTime() { return RunFile::closeTime; };
	static long getReadTime() { return RunFile::readTime; };
	static long getWriteTime() { return RunFile::writeTime; };
	static void printTime() {
		cout<<"Open:"<<RunFile::openTime
			<<"Close:"<<RunFile::closeTime
			<<"Read:"<<RunFile::readTime
			<<"Write:"<<RunFile::writeTime
			<<"Total:"<<RunFile::openTime
			+RunFile::closeTime+RunFile::readTime
			+RunFile::writeTime<<endl;
		cout<<"open+close:"<<RunFile::openTime+RunFile::closeTime
			<<"write+read:"<<RunFile::writeTime+RunFile::readTime<<endl;
	};

	private:
		char* fname;
		char mode;
		bool exist;   //true---exist, false---delete
		FILE* ff;
		static long openTime;
		static long readTime;
		static long closeTime;
		static long writeTime;
		struct timeval tval;
		struct timeval tval1;

		long getDiff();

};

#endif
